// StandardConsumer.java


import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.space.Discrete2dImpl;
import swarm.space.Grid2dImpl;

import swarm.gui.Raster;
import swarm.gui.ZoomRasterImpl;
import java.io.*;
public class StandardConsumer extends SwarmObjectImpl
{
    // These instance variables keep track of a given consumer's marketspace,
    // position and identity.  We also save the dimensions of the
    // marketspace so that we can make fewer calls to the getSizeX() and
    // getSizeY() methods in the consumer's randomWalk().
    
    public Grid2dImpl myConsumerSpace;
    public int xPos;
    public int yPos;
    public int consumerNumber;
    int worldXSize;
    int worldYSize;
    public double consumerPrice;
    
    public int consumerWalk;
    public int consumerOptimism;
    //inserisco la variabile per rendere selezionabile la lunghezza del passo
   
    public byte consumerColor;
    public int consumerResearch;
    // Constructor to create a StandardConsumer object in Zone aZone and to
    // place it in the consumerspace, fSpace and cSpace, at
    // the specified X,Y location. The consumer is also given a numeric id,
    // bNum.

  
    public StandardConsumer(Zone aZone, Grid2dImpl cSpace, 
		     int X, int Y, int cNum, double cPrice, int cWalk, int cOptimism, int cResearch)
    {
	// Call the constructor for the bug's parent class.
	super(aZone);

	// Record the bug's foodspace, bugspace, initial position and
	// id number.
	//Inizializzo le variabili
	myConsumerSpace = cSpace;	
	worldXSize = 80;
	worldYSize = 80;
	xPos = X;
	yPos = Y;
	consumerNumber = cNum;
	consumerPrice = cPrice;
	consumerWalk = cWalk;
	consumerOptimism = cOptimism;
	consumerResearch = cResearch;
    }

  	
// consumerWalk= modelSwarm.getWalk();

    // This is the method to have the bug take a random walk backward
    // (-1), forward (+1), or not at all (0) in first the X and then
    // the Y direction.  The randomWalk method uses
    // getIntegerWithMin$withMax() to return an integer between a
    // minimum and maximum value, here between -1 and +1.
    // Globals.env.uniformRand is an instance of the class
    // UniformIntegerDistImpl, instantiated by the call to
    // Globals.env.initSwarm in StartSimpleBug.  Note that the bug's
    // world is a torus.  If the bug walks off the edge of its
    // rectangular world, it is magically transported (via the modulus
    // operator) to the opposite edge.  If on its walk the bug finds
    // food, it eats it and turns on the haveEaten flag so it can
    // report its feast if asked.  Note that before the bug actually
    // moves, we must check to see that there is no other bug at the
    // destination cell.  If there is, the this bug just stays put.
    
public double getConsumerPrice () {
    return consumerPrice;
  }
  
    //metodo che restituisce all'observer il consumer price per ilgrafico
	
 public void randomWalk()
    {
	
	int newX, newY;
	double saving;
	//saving  il risparmio compiuto dal consumatore nell'acquistare ad un 
	//prezzo inferiore a quello predefinito. 
	
	//aConsumerWalk = ModelSwarm.getWalk;
	//	consumerWalk= modelSwarm.getWalk();
	//con il metodo Random Walk decido dove deve muoversi in modo 
	//casuale il consumatore, il passo  compreso tra -3 et + 3 caselle
	//all'interno del mondo
	newX = xPos + 
            Globals.env.uniformIntRand.getIntegerWithMin$withMax(-consumerWalk, +consumerWalk);
	newY = yPos +
	    Globals.env.uniformIntRand.getIntegerWithMin$withMax(-consumerWalk, +consumerWalk);
	newX = (newX + worldXSize) % worldXSize;
	newY = (newY + worldYSize) % worldYSize;

	//	 System.out.println( "Il consumatore " + consumerNumber + " si sposta nella posizione " + newX + " " + newY +" con un prezzo di " + consumerPrice);
	 //passo a video la posizione dei consumatori
	//disabilito la funzione verificato il corretto svolgimento della procedura
	
	if (myConsumerSpace.getObjectAtX$Y(newX, newY) == null)
	    {
		myConsumerSpace.putObject$atX$Y(null, xPos, yPos);
		xPos = newX;
		yPos = newY;
		myConsumerSpace.putObject$atX$Y(this, xPos, yPos);
		StandardEnterprice enterprice = ModelSwarm.getEnterprice(xPos, yPos);
		//carico le caratterisitche delle imprese, se le imprese sono 
		//sulle posizioni x y implica != da null allora se anche 
		//il prezzo importato da get.Price  minore del prezzo
		// di riserva del consumatore allora il consumatore
		//acquista e aggiorna il suo prezzo a quello a cui ha acquistato
		//ovvero abbassa , se non era gi uguale il suo prezzo di acquisto a quell0
		// a cui l'impresa vende. Per vedere a video il tutto il consumatore contento di avere acquistato
		//cambia colore e diventa di colore verde.
		//A conferma dell' avvenuta scambio a video si stampa  
		if (enterprice != null)
		    if (enterprice.getPrice()<=consumerPrice)    {
			consumerColor= 2;
			 	
			//cambio il colore quando acquisto
			saving = consumerPrice - enterprice.getPrice();
			System.out.println( "il consumatore " + consumerNumber +  " acquista dall'impresa  " + enterprice.getNum()+ " al prezzo di  " + enterprice.getPrice());
			System.out.println( " risparimiando rispetto a quanto era disposto a spendere "+ saving);

	     consumerPrice= enterprice.getPrice();
	     consumerPrice =consumerPrice- consumerOptimism;
	     //metodo per il consumatore "egoista" butta gi il prezzo.
	     System.out.println( "La sua disponibilit a pagare, scende al prezzo di acquisto ridotto di "+ consumerOptimism + "(new p=" + consumerPrice+ ")." );
	     System.out.println(" ");
		   }
		    else{ consumerColor= 1;
		    //il conusmatore arrabbiato diventa rosso.
		    //aggiorna il suo prezzo 
		     System.out.println("Il consumatore "+ consumerNumber + " non compra  dall' impresa "+enterprice.getNum()+" perch il prezzo (" +enterprice.getPrice()+ ")  troppo  caro!");
		     System.out.println("il consumatore non voleva spendere pi di " + consumerPrice);
		      consumerPrice=enterprice.getPrice()- consumerResearch;
		      System.out.println("Sconsolato, aumenta la sua disponibilit a pagare a "+consumerPrice+ ".");
		      System.out.println(" ");
		//aggiorno il prezzo del consumatore;
		    }
 }


	    
    }


    // Metodo che definisce il colore: 3 = giallo , 1= rosso, 4= blu, 2=verde
  
    public Object setConsumerColor(byte c)
    { 
	consumerColor = 4; 
	return this; 
    }

    public Object drawSelfOn (Raster r)
    {
	r.drawPointX$Y$Color (xPos, yPos, consumerColor);
	return this;
    }

     


}

