// MarketSpace.java
// Defines the MarketSpace class as a subclass of Discrete2dImpl.

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.space.Discrete2dImpl;

public class MarketSpace extends Discrete2dImpl
{
    // The constructor for a foodspace.  Create a foodspace in zone
    // aZone with dimensions xSize and ySize.  Note that a
    // food space is based on the Swarm's Discrete2dImpl class.
    public MarketSpace(Zone aZone, int xSize, int ySize)
    {
	// Call the constructor for the parent class and then fill the
	// lattice with zeros.
	super(aZone, xSize, ySize);
	fastFillWithValue(0);
    }
  
}
