// StandardEnterprice.java

import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

import swarm.space.Discrete2dImpl;
import swarm.space.Grid2dImpl;

import swarm.gui.Raster;
import swarm.gui.ZoomRasterImpl;

public class StandardEnterprice extends SwarmObjectImpl
{
   
    public Grid2dImpl myEnterpriceSpace;
    public int xPos;
    public int yPos;
    public int enterpriceNumber;
    int worldXSize;
    int worldYSize;
    double enterpricePrice;
    
    public byte enterpriceColor;

    public StandardEnterprice(Zone aZone,  Grid2dImpl eSpace, 
		     int X, int Y, int eNum, double ePrice)
    {
	// Call the constructor for the bug's parent class.
	super(aZone);

	// Record the bug's foodspace, bugspace, initial position and
	// id number.
	
	myEnterpriceSpace = eSpace;
	worldXSize = 80;
	worldYSize = 80;
	xPos = X;
	yPos = Y;
	enterpriceNumber = eNum;
	enterpricePrice = ePrice;


    }

    public int getNum (){ 
	return enterpriceNumber; 
	 
    
	//rende il numero delle imprese
    }

    public double getPrice (){ 
	return enterpricePrice ; 
	//rende il prezzo delle singole imprese
    }

   
    public Object setEnterpriceColor(byte c)
    { 
	enterpriceColor = 3; 
	return this; 
    }

    public Object DrawSelfOn (Raster r)
    {
	r.drawPointX$Y$Color (xPos, yPos, enterpriceColor);
	return this;
    }
}

